-- Ben Lin 5/98
class ELIMINATION inherit OBSERVER
	-- Whenever a row or column only has one empty square left,
	-- and the rest of the squares are crossed out, this generates
	-- an `ADD_TICK' command on that empty square. Also, if all
	-- the squares are crossed out, it kills the blackboard.
creation make
feature
	make is
	do
	end

	update(last : ADD_CROSS) is
	local
		i, j, x, y : INTEGER
		found : INTEGER
		bb : LP_BOARD
	do
		bb := last.bb
		i := last.i
		j := last.j
		x := last.x
		from
			y := 1
			found := 0
		until y > bb.size or found = -1
		loop
			inspect(bb.board.item(i, j, x, y))
			when 0 then
				if found = 0 then
					found := y
				else
					found := -1
				end
			when 1 then
				found := -1
			else
			end
			y := y + 1
		end

		y := last.y

		if found /= -1 then
			last.forced_tick(i, j, x, found)
		end

		from
			x := 1
			found := 0
		until x > bb.size
		loop
			inspect(bb.board.item(i, j, x, y))
			when 0 then
				if found = 0 then
					found := x
				else
					found := -1
				end
			when 1 then
				found := -1
			else
			end
			x := x + 1
		end

		if found /= -1 then
			last.forced_tick(i, j, found, y)
		end
	end

end
