-- Ben Lin 28/5/98
class SMALLER_THAN inherit OBSERVER
	-- Opposite of larger_than.e.
creation make
feature
	make(smalli, smallx, bigi, bigx, attr : INTEGER) is
	do
		i1 := smalli
		x1 := smallx
		i2 := bigi
		x2 := bigx
		j := attr
	end

	update(last : LP_COMMAND) is
	local
		found : INTEGER
		y : INTEGER
		done : BOOLEAN
		bb : LP_BOARD
	do
		bb := last.bb

		-- find the minimum of smalli, smallx - bigi, bigx, must be larger
		-- than this
		from
			found := 1
			done := false
		until found = bb.size or done
		loop
			inspect bb.board.item(i1, j, x1, found)
			when -1 then
				found := found + 1
			else
				done := true
			end
		end

		if found = bb.size then
			-- if it's bb.size, there's no way it can be smaller than
			-- anyting else
			last.forced_die
		else
			-- now cross out squares that imply small >= big
			from y := 1
			until y > found
			loop
				inspect bb.board.item(i2, j, x2, y)
				when 0 then
					last.forced_cross(i2, j, x2, y)
				when 1 then
					last.forced_die
				else
				end
				y := y + 1
			end
		end
	end

feature {NONE}
	i1, x1, i2, x2, j : INTEGER
end

